//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

string	quitsounds[5] =
{
	"QuitMessage1",
	"QuitMessage2",
	"QuitMessage3",
	"QuitMessage4",
	"QuitMessage5",
};

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	QuitResponse
//
//==========================================================================

void QuitResponse(int ch)
{
    if (ch != 'y')
		return;

   	LocalSoundTillDone(quitsounds[P_Random() % 5]);

	CmdBuf_AddText("Quit\n");
}

//==========================================================================
//
//	menu_quit
//
//==========================================================================

void menu_quit(void)
{
	MB_StartMessage("Do you really want to leave?\n\n(press y to quit)", QuitResponse, true);
}


