;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_DATA SEGMENT
 align 4
itransluc:
 dd 0
_DATA ENDS
_TEXT SEGMENT
 align 4
 public _D_DrawFuzzSpan_15
_D_DrawFuzzSpan_15:
 sub esp,44
 push ebp
 push edi
 push esi
 push ebx
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 mov eax,ds:dword ptr[_ds_count]
 mov ds:dword ptr[36+esp],eax
 mov edx,ds:dword ptr[_ds_fz]
 mov ds:dword ptr[32+esp],edx
 mov ecx,ds:dword ptr[_ds_fr]
 mov ds:dword ptr[28+esp],ecx
 mov eax,ds:dword ptr[_ds_y]
 mov edx,ds:dword ptr[_ylookup+eax*4]
 add edx,ds:dword ptr[_ds_x]
 add edx,edx
 mov ebp,edx
 add ebp,ds:dword ptr[_scrn16]
 add edx,ds:dword ptr[_zbuffer]
 mov ds:dword ptr[24+esp],edx
 mov eax,256
 sub eax,ds:dword ptr[_ds_transluc16]
 mov ds:dword ptr[itransluc],eax
 jmp LEnter
 align 4
LLoop:
 fxch st(2)
 fadd ds:dword ptr[_ds_dsdx]
 fxch st(1)
 fadd ds:dword ptr[_ds_dtdx]
 fxch st(2)
 fadd ds:dword ptr[_ds_dvdx]
 fxch st(1)
 fxch st(2)
 fxch st(1)
 mov eax,ds:dword ptr[_ds_fdzdx]
 mov edx,ds:dword ptr[_ds_fdrdx]
 add ds:dword ptr[32+esp],eax
 add ds:dword ptr[28+esp],edx
 add ebp,2
 add ds:dword ptr[24+esp],2
LEnter:
 mov edx,ds:dword ptr[24+esp]
 mov eax,ds:dword ptr[32+esp]
 shr eax,16
 cmp ax,ds:word ptr[edx]
 jb LSkipPixel
 fld1
 fdiv st,st(1)
 fld st(3)
 fmul st,st(1)
 fistp ds:dword ptr[40+esp]
 mov ecx,ds:dword ptr[40+esp]
 and ecx,255
 fld st(2)
 fmulp st(1),st
 fistp ds:dword ptr[40+esp]
 mov eax,ds:dword ptr[40+esp]
 and eax,255
 mov edx,ds:dword ptr[_ds_source]
 shl eax,8
 add eax,ecx
 mov al,ds:byte ptr[eax+edx]
 cmp al,255
 je LSkipPixel
 movzx edx,al
 mov eax,ds:dword ptr[28+esp]
 sar eax,11
 and eax,7936
 add edx,eax
 mov eax,ds:dword ptr[_ds_colormap16]
 movzx ebx,ds:word ptr[ebp]
 mov edi,ebx
 and edi,31744
 shr di,7
 and ebx,992
 shr bx,2
 mov cl,ds:byte ptr[ebp]
 sal cl,3
 movzx ebx,bl
 movzx esi,ds:word ptr[eax+edx*2]
 mov ds:byte ptr[23+esp],cl
 mov ecx,esi
 sal cl,3
 mov ds:byte ptr[22+esp],cl
 mov ecx,edi
 movzx edi,cl
 mov ds:dword ptr[16+esp],edi
 mov edi,ds:dword ptr[_ds_transluc16]
 mov ecx,ds:dword ptr[16+esp]
 mov eax,esi
 mov edx,esi
 mov esi,ds:dword ptr[itransluc]
 imul ecx,edi
 and eax,31744
 shr ax,7
 movzx eax,al
 imul eax,esi
 imul ebx,edi
 and edx,992
 shr dx,2
 movzx edx,dl
 imul edx,esi
 add ebx,edx
 movzx edx,ds:byte ptr[23+esp]
 imul edx,edi
 add ecx,eax
 movzx eax,ds:byte ptr[22+esp]
 imul eax,esi
 shr ecx,8
 shr ebx,8
 add edx,eax
 sal ecx,7
 and ecx,31744
 lea eax,ds:dword ptr[0+ebx*4]
 and eax,992
 or ecx,eax
 shr edx,11
 and edx,31
 or ecx,edx
 mov ds:word ptr[ebp],cx
LSkipPixel:
 dec ds:dword ptr[36+esp]
 jnz LLoop
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebx
 pop esi
 pop edi
 pop ebp
 add esp,44
 ret
_TEXT ENDS
 END
