//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.data
	Align4
itransluc:
	.long 0

.text

//==========================================================================
//
//	D_DrawFuzzSpriteSpan_15
//
//==========================================================================

	Align16
.globl C(D_DrawFuzzSpriteSpan_15)
C(D_DrawFuzzSpriteSpan_15):

	subl	$44,%esp
	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	flds	C(ds_s)
	flds	C(ds_t)
	flds	C(ds_v)

	movl	C(ds_count),%eax
	movl	%eax,36(%esp)

	movl	C(ds_fz),%edx
	movl	%edx,32(%esp)

	movl	C(ds_fr),%ecx
	movl	%ecx,28(%esp)

	movl	C(ds_y),%eax
	movl	C(ylookup)(,%eax,4),%edx
	addl	C(ds_x),%edx
	addl	%edx,%edx
	movl	%edx,%ebp
	addl	C(scrn16),%ebp
	addl	C(zbuffer),%edx
	movl	%edx,24(%esp)

	movl	$256,%eax
	subl	C(ds_transluc16),%eax
	movl	%eax,itransluc

	jmp		LEnter

	Align16
LLoop:
	fxch	%st(2)
	fadds	C(ds_dsdx)
	fxch	%st(1)
	fadds	C(ds_dtdx)
	fxch	%st(2)
	fadds	C(ds_dvdx)
	fxch	%st(1)
	fxch	%st(2)
	fxch	%st(1)
	movl	C(ds_fdzdx),%eax
	movl	C(ds_fdrdx),%edx
	addl	%eax,32(%esp)
	addl	%edx,28(%esp)
	addl	$2,%ebp
	addl	$2,24(%esp)
LEnter:
	movl	24(%esp),%edx
	movl	32(%esp),%eax
	shrl	$16,%eax
	cmpw	(%edx),%ax
	jb		LSkipPixel

	fld1
	fdiv	%st(1),%st
	fld		%st(3)
	fmul	%st(1),%st
	fistpl	40(%esp)
	movl	40(%esp),%ecx
	fld		%st(2)
	fmulp	%st,%st(1)
	fistpl	40(%esp)
	movl	40(%esp),%eax
	movl	C(ds_source),%edx
	imull	C(ds_tex_width),%eax
	addl	%ecx,%eax
	movb	(%eax,%edx),%al
	cmpb	$255,%al
	je		LSkipPixel

	movzbl	%al,%edx
	movl	28(%esp),%eax
	sarl	$11,%eax
	andl	$7936,%eax
	addl	%eax,%edx
	movl	C(ds_colormap16),%eax
	movzwl	(%ebp),%ebx
	movl	%ebx,%edi
	andl	$31744,%edi
	shrw	$7,%di
	andl	$992,%ebx
	shrw	$2,%bx
	movb	(%ebp),%cl
	salb	$3,%cl
	movzbl	%bl,%ebx
	movzwl	(%eax,%edx,2),%esi
	movb	%cl,23(%esp)
	movl	%esi,%ecx
	salb	$3,%cl
	movb	%cl,22(%esp)
	movl	%edi,%ecx
	movzbl	%cl,%edi
	movl	%edi,16(%esp)
	movl	C(ds_transluc16),%edi
	movl	16(%esp),%ecx
	movl	%esi,%eax
	movl	%esi,%edx
	movl	itransluc,%esi
	imull	%edi,%ecx
	andl	$31744,%eax
	shrw	$7,%ax
	movzbl	%al,%eax
	imull	%esi,%eax
	imull	%edi,%ebx
	andl	$992,%edx
	shrw	$2,%dx
	movzbl	%dl,%edx
	imull	%esi,%edx
	addl	%edx,%ebx
	movzbl	23(%esp),%edx
	imull	%edi,%edx
	addl	%eax,%ecx
	movzbl	22(%esp),%eax
	imull	%esi,%eax
	shrl	$8,%ecx
	shrl	$8,%ebx
	addl	%eax,%edx
	sall	$7,%ecx
	andl	$31744,%ecx
	leal	0(,%ebx,4),%eax
	andl	$992,%eax
	orl		%eax,%ecx
	shrl	$11,%edx
	andl	$31,%edx
	orl		%edx,%ecx
	movw	%cx,(%ebp)

LSkipPixel:
	decl	36(%esp)
	jnz		LLoop

	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$44,%esp
	ret

#endif
