//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.text

//==========================================================================
//
//	D_DrawAltFuzzSpriteSpan_8
//
//==========================================================================

	Align16
.globl C(D_DrawAltFuzzSpriteSpan_8)
C(D_DrawAltFuzzSpriteSpan_8):

	subl	$28,%esp
	pushl	%ebp
	movl	C(ds_fz),%ebp
	movl	C(ds_fr),%eax
	flds	C(ds_s)
	flds	C(ds_t)
	flds	C(ds_v)
	flds	C(ds_dsdx)
	flds	C(ds_dtdx)
	flds	C(ds_dvdx)
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	movl	%eax,20(%esp)
	movl	C(ds_y),%eax
	movl	C(ylookup)(,%eax,4),%edx
	movl	C(ds_x),%ecx
	movl	%edx,%eax
	addl	C(scrn),%eax
	leal	(%ecx,%eax),%ebx
	movl	C(zbuffer),%eax
	movl	C(ds_count),%esi
	leal	(%eax,%edx,2),%edx
	leal	(%edx,%ecx,2),%edi
	jmp		LEnter

	Align16
LLoop:
	fxch	%st(3)
	fxch	%st(4)
	fxch	%st(5)
LEnter:
	movl	%ebp,%eax
	shrl	$16,%eax
	cmpw	(%edi),%ax
	jb		LSkipPixel
	fld1
	fdiv	%st(4),%st
	fld		%st(6)
	fmul	%st(1),%st
	fistpl	24(%esp)
	movl	24(%esp),%ecx
	fld		%st(5)
	fmulp	%st,%st(1)
	fistpl	24(%esp)
	movl	24(%esp),%eax
	movl	C(ds_source),%edx
	imull	C(ds_tex_width),%eax
	addl	%ecx,%eax
	movb	(%eax,%edx),%al
	cmpb	$255,%al
	je		LSkipPixel
	movzbl	%al,%edx
	movl	20(%esp),%eax
	movl	C(ds_colormap),%ecx
	sarl	$11,%eax
	andl	$7936,%eax
	addl	%eax,%edx
	movzbl	(%ebx),%eax
	movzbl	(%edx,%ecx),%edx
	movl	C(ds_transluc),%ecx
	sall	$8,%eax
	addl	%edx,%eax
	movb	(%eax,%ecx),%al
	movb	%al,(%ebx)
LSkipPixel:
	fxch	%st(5)
	movl	C(ds_fdrdx),%eax
	fadd	%st(2),%st
	fxch	%st(4)
	fadd	%st(1),%st
	fxch	%st(3)
	fadd	%st(5),%st
	addl	C(ds_fdzdx),%ebp
	addl	%eax,20(%esp)
	incl	%ebx
	addl	$2,%edi
	decl	%esi
	jnz		LLoop

	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$28,%esp
	ret

#endif
