;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_DATA SEGMENT
 align 4
s:
 dd 0
t:
 dd 0
_DATA ENDS
_TEXT SEGMENT
 align 4
 public _D_DrawDoubleSkySpan_8
_D_DrawDoubleSkySpan_8:
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 fld ds:dword ptr[_ds_dsdx]
 fld ds:dword ptr[_ds_dtdx]
 fld ds:dword ptr[_ds_dvdx]
 fld1
 fdiv st,st(4)
 push edi
 push esi
 push ebx
 push ebp
 mov edi,ds:dword ptr[_ds_x]
 mov eax,ds:dword ptr[_ds_y]
 add edi,ds:dword ptr[_ylookup+eax*4]
 add edi,ds:dword ptr[_scrn]
 mov ecx,ds:dword ptr[_ds_count]
 mov esi,ds:dword ptr[_ds_source]
 jmp LEnter
 align 4
LLoop:
 fadd st(3),st
 fxch st(1)
 fadd st(4),st
 fxch st(1)
 fxch st(2)
 fadd st(5),st
 fxch st(2)
 fld1
 fdiv st,st(4)
 mov eax,ds:dword ptr[s]
 mov edx,ds:dword ptr[t]
 and eax,1023
 and edx,255
 shl edx,10
 or edx,eax
 mov al,ds:byte ptr[edx+esi]
 and eax,255
 jz LSkipPixel1
 mov ds:byte ptr[edi],al
LSkipPixel1:
 inc edi
LEnter:
 fld st
 fmul st,st(7)
 fistp ds:dword ptr[s]
 fmul st,st(5)
 fistp ds:dword ptr[t]
 dec ecx
 jnz LLoop
 mov eax,ds:dword ptr[s]
 mov edx,ds:dword ptr[t]
 and eax,1023
 and edx,255
 shl edx,10
 or edx,eax
 mov al,ds:byte ptr[edx+esi]
 and eax,255
 jz LSkipPixel2
 mov ds:byte ptr[edi],al
LSkipPixel2:
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebp
 pop ebx
 pop esi
 pop edi
 ret
_TEXT ENDS
 END
