;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_DATA SEGMENT
 align 4
s:
 dd 0
t:
 dd 0
_DATA ENDS
_TEXT SEGMENT
 align 4
 public _D_DrawFuzzSpriteSpan_8
_D_DrawFuzzSpriteSpan_8:
 push ebp
 push edi
 push esi
 push ebx
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 fld ds:dword ptr[_ds_dsdx]
 fld ds:dword ptr[_ds_dtdx]
 fld ds:dword ptr[_ds_dvdx]
 mov ebx,ds:dword ptr[_ds_fz]
 mov edi,ds:dword ptr[_ds_fr]
 mov eax,ds:dword ptr[_ds_y]
 mov esi,ds:dword ptr[_ylookup+eax*4]
 add esi,ds:dword ptr[_ds_x]
 mov ebp,esi
 add esi,ds:dword ptr[_scrn]
 add ebp,ebp
 add ebp,ds:dword ptr[_zbuffer]
 mov ecx,ds:dword ptr[_ds_count]
 jmp LEnter
 align 4
LLoop:
 add ebx,ds:dword ptr[_ds_fdzdx]
 add edi,ds:dword ptr[_ds_fdrdx]
 inc esi
 add ebp,2
 fxch st(2)
 fadd st(5),st
 fxch st(2)
 fxch st(1)
 fadd st(4),st
 fxch st(1)
 fadd st(3),st
LEnter:
 mov eax,ebx
 shr eax,16
 cmp ax,ds:word ptr[ebp]
 jb LSkipPixel
 fld1
 fdiv st,st(4)
 fld st
 fmul st,st(7)
 fistp ds:dword ptr[s]
 fmul st,st(5)
 fistp ds:dword ptr[t]
 mov eax,ds:dword ptr[t]
 imul eax,ds:dword ptr[_ds_tex_width]
 add eax,ds:dword ptr[s]
 mov edx,ds:dword ptr[_ds_source]
 mov al,ds:byte ptr[eax+edx]
 cmp al,255
 je LSkipPixel
 movzx edx,al
 mov eax,edi
 shr eax,11
 and eax,7936
 add eax,edx
 mov edx,ds:dword ptr[_ds_colormap]
 movzx eax,ds:byte ptr[eax+edx]
 shl eax,8
 mov al,ds:byte ptr[esi]
 mov edx,ds:dword ptr[_ds_transluc]
 mov al,ds:byte ptr[edx+eax]
 mov ds:byte ptr[esi],al
LSkipPixel:
 dec ecx
 jnz LLoop
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebx
 pop esi
 pop edi
 pop ebp
 ret
_TEXT ENDS
 END
