;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_DATA SEGMENT
 align 4
s:
 dd 0
t:
 dd 0
zz:
 dd 0
_DATA ENDS
_TEXT SEGMENT
 align 4
 public _D_DrawMaskedSpan_8
_D_DrawMaskedSpan_8:
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 fld ds:dword ptr[_ds_dsdx]
 fld ds:dword ptr[_ds_dtdx]
 fld ds:dword ptr[_ds_dvdx]
 fld1
 fdiv st,st(4)
 push edi
 push esi
 push ebx
 push ebp
 mov ebp,ds:dword ptr[_ds_fr]
 mov eax,ds:dword ptr[_ds_fz]
 mov ds:dword ptr[zz],eax
 mov ecx,ds:dword ptr[_ds_count]
 mov ebx,ds:dword ptr[_ds_source]
 mov eax,ds:dword ptr[_ds_y]
 mov esi,ds:dword ptr[_ylookup+eax*4]
 add esi,ds:dword ptr[_ds_x]
 mov edi,esi
 add edi,ds:dword ptr[_scrn]
 add esi,esi
 add esi,ds:dword ptr[_zbuffer]
 jmp LEnter
 align 4
LLoop:
 fadd st(3),st
 fxch st(1)
 fadd st(4),st
 fxch st(1)
 fxch st(2)
 fadd st(5),st
 fxch st(2)
 fld1
 fdiv st,st(4)
 mov edx,ds:dword ptr[s]
 mov eax,ds:dword ptr[t]
 and edx,255
 and eax,255
 shl eax,8
 add edx,eax
 mov eax,ebp
 shr eax,11
 mov al,ds:byte ptr[edx+ebx]
 cmp al,255
 je LSkipPixel1
 mov edx,ds:dword ptr[_ds_colormap]
 mov al,ds:byte ptr[edx+eax]
 mov ds:byte ptr[edi],al
 mov eax,ds:dword ptr[zz]
 shr eax,16
 mov ds:word ptr[esi],ax
LSkipPixel1:
 mov eax,ds:dword ptr[_ds_fdzdx]
 add ds:dword ptr[zz],eax
 add ebp,ds:dword ptr[_ds_fdrdx]
 inc edi
 add esi,2
LEnter:
 fld st(6)
 fmul st,st(1)
 fistp ds:dword ptr[s]
 fld st(5)
 fmulp st(1),st
 fistp ds:dword ptr[t]
 dec ecx
 jnz LLoop
 mov edx,ds:dword ptr[s]
 mov eax,ds:dword ptr[t]
 and edx,255
 and eax,255
 shl eax,8
 add edx,eax
 mov eax,ebp
 shr eax,11
 mov al,ds:byte ptr[edx+ebx]
 cmp al,255
 je LSkipPixel2
 mov edx,ds:dword ptr[_ds_colormap]
 mov al,ds:byte ptr[edx+eax]
 mov ds:byte ptr[edi],al
 mov eax,ds:dword ptr[zz]
 shr eax,16
 mov ds:word ptr[esi],ax
LSkipPixel2:
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebp
 pop ebx
 pop esi
 pop edi
 ret
_TEXT ENDS
 END
