;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_TEXT SEGMENT
 align 4
 public _D_MakeSpans
_D_MakeSpans:
 sub esp,28
 push ebp
 push edi
 push esi
 push ebx
 mov esi,ds:dword ptr[_freespans]
 test esi,esi
 je LExitNull
 mov ecx,ds:dword ptr[48+esp]
 movsx edx,ds:word ptr[174+ecx]
 movsx eax,ds:word ptr[178+ecx]
 mov edi,eax
 sub edi,edx
 test edi,edi
 jle LExitNull
 mov ds:dword ptr[4+esi],edx
 mov ds:dword ptr[8+esi],edi
 mov eax,ds:dword ptr[196+ecx]
 mov ds:dword ptr[12+esi],eax
 mov eax,ds:dword ptr[208+ecx]
 mov ds:dword ptr[16+esi],eax
 mov eax,ds:dword ptr[220+ecx]
 mov ds:dword ptr[20+esi],eax
 mov eax,ds:dword ptr[232+ecx]
 mov ds:dword ptr[24+esi],eax
 mov eax,ds:dword ptr[244+ecx]
 mov ds:dword ptr[28+esi],eax
 mov eax,ds:dword ptr[132+ecx]
 mov ds:dword ptr[32+esi],eax
 mov eax,ds:dword ptr[144+ecx]
 mov ds:dword ptr[36+esi],eax
 mov eax,ds:dword ptr[148+ecx]
 mov ds:dword ptr[40+esi],eax
 mov eax,ds:dword ptr[156+ecx]
 mov ds:dword ptr[44+esi],eax
 mov eax,ds:dword ptr[164+ecx]
 mov ds:dword ptr[48+esi],eax
 mov eax,ds:dword ptr[268+ecx]
 mov ds:dword ptr[52+esi],eax
 mov eax,ds:dword ptr[272+ecx]
 mov ds:dword ptr[56+esi],eax
 mov eax,ds:dword ptr[276+ecx]
 mov ds:dword ptr[60+esi],eax
 mov eax,ds:dword ptr[280+ecx]
 mov ds:dword ptr[64+esi],eax
 mov eax,ds:dword ptr[esi]
 mov edi,ds:dword ptr[8+esi]
 mov ecx,ds:dword ptr[_spanlist]
 mov ds:dword ptr[_freespans],eax
 add edi,ds:dword ptr[4+esi]
 xor ebp,ebp
 test ecx,ecx
 je LAddToList
 mov edx,ds:dword ptr[4+ecx]
 cmp edx,edi
 jge LAddToList
 add edx,ds:dword ptr[8+ecx]
 cmp edx,edi
 jg LSplitSpan
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveNoPrev
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
LNextSpan:
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveSpan
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveSpan
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveSpan
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveSpan
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 jmp LNextSpan
 align 4
LRemoveSpan:
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 mov ds:dword ptr[ebp],ecx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 mov ds:dword ptr[ebp],ecx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 mov ds:dword ptr[ebp],ecx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 mov ds:dword ptr[ebp],ecx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 jmp LRemoveSpan
 align 4
LRemoveNoPrev:
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 test ecx,ecx
 je LAddToList
 mov eax,ds:dword ptr[4+ecx]
 cmp eax,edi
 jge LAddToList
 add eax,ds:dword ptr[8+ecx]
 cmp eax,edi
 jg LSplitSpan
 jmp LRemoveNoPrev
 align 4
LSplitSpan:
 mov ebx,ds:dword ptr[_freespans]
 test ebx,ebx
 je LAddToList
 mov eax,ds:dword ptr[ebx]
 mov ds:dword ptr[_freespans],eax
 mov eax,ds:dword ptr[8+ecx]
 mov edx,edi
 sub edx,ds:dword ptr[4+ecx]
 sub eax,edx
 mov ds:dword ptr[8+ebx],eax
 mov ds:dword ptr[4+ebx],edi
 mov eax,edx
 imul eax,ds:dword ptr[32+ecx]
 add eax,ds:dword ptr[12+ecx]
 mov ds:dword ptr[12+ebx],eax
 mov eax,edx
 imul eax,ds:dword ptr[36+ecx]
 add eax,ds:dword ptr[16+ecx]
 mov ds:dword ptr[16+ebx],eax
 mov ds:dword ptr[28+esp],edx
 fild ds:dword ptr[28+esp]
 fld st(0)
 fmul ds:dword ptr[40+ecx]
 fadd ds:dword ptr[20+ecx]
 fstp ds:dword ptr[20+ebx]
 fld st(0)
 fmul ds:dword ptr[44+ecx]
 fadd ds:dword ptr[24+ecx]
 fstp ds:dword ptr[24+ebx]
 fmul ds:dword ptr[48+ecx]
 fadd ds:dword ptr[28+ecx]
 fstp ds:dword ptr[28+ebx]
 mov eax,ds:dword ptr[32+ecx]
 mov ds:dword ptr[32+ebx],eax
 mov eax,ds:dword ptr[36+ecx]
 mov ds:dword ptr[36+ebx],eax
 mov eax,ds:dword ptr[40+ecx]
 mov ds:dword ptr[40+ebx],eax
 mov eax,ds:dword ptr[44+ecx]
 mov ds:dword ptr[44+ebx],eax
 mov eax,ds:dword ptr[48+ecx]
 mov ds:dword ptr[48+ebx],eax
 mov eax,ds:dword ptr[52+ecx]
 mov ds:dword ptr[52+ebx],eax
 mov eax,ds:dword ptr[56+ecx]
 mov ds:dword ptr[56+ebx],eax
 mov eax,ds:dword ptr[60+ecx]
 mov ds:dword ptr[60+ebx],eax
 mov eax,ds:dword ptr[64+ecx]
 mov ds:dword ptr[64+ebx],eax
 mov eax,ds:dword ptr[ecx]
 mov ds:dword ptr[ebx],eax
 mov ds:dword ptr[ecx],ebx
 mov ds:dword ptr[8+ecx],edx
 mov eax,ds:dword ptr[4+esi]
 cmp ds:dword ptr[4+ecx],eax
 jge LRemoveSpan2
 mov ebp,ecx
 mov ecx,ds:dword ptr[ebp]
 jmp LAddToList
 align 4
LRemoveSpan2:
 mov edx,ecx
 mov ecx,ds:dword ptr[ecx]
 mov eax,ds:dword ptr[_freespans]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[_freespans],edx
 test ebp,ebp
 je LAddToList
 mov ds:dword ptr[ebp],ecx
 jmp LAddToList
 align 4
LAddToList:
 mov ds:dword ptr[esi],ecx
 test ebp,ebp
 je LAddAtHead
 mov eax,ds:dword ptr[4+ebp]
 mov ds:dword ptr[ebp],esi
 mov edx,ds:dword ptr[4+esi]
 sub edx,eax
 cmp ds:dword ptr[8+ebp],edx
 jl LExit2
 mov ds:dword ptr[8+ebp],edx
 jmp LExit2
 align 4
LAddAtHead:
 mov ds:dword ptr[_spanlist],esi
LExit2:
 mov eax,esi
LExit:
 pop ebx
 pop esi
 pop edi
 pop ebp
 add esp,28
 ret
 align 4
LExitNull:
 xor eax,eax
 jmp LExit
_TEXT ENDS
 END
