//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.text

//==========================================================================
//
//	D_MakeSpans
//
//==========================================================================

	Align16
.globl C(D_MakeSpans)
C(D_MakeSpans):
	subl	$28,%esp
	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	movl	C(freespans),%esi
	testl	%esi,%esi
	je		LExitNull
	movl	48(%esp),%ecx
	movswl	174(%ecx),%edx
	movswl	178(%ecx),%eax
	movl	%eax,%edi
	subl	%edx,%edi
	testl	%edi,%edi
	jle		LExitNull
	movl	%edx,4(%esi)
	movl	%edi,8(%esi)
	movl	196(%ecx),%eax
	movl	%eax,12(%esi)
	movl	208(%ecx),%eax
	movl	%eax,16(%esi)
	movl	220(%ecx),%eax
	movl	%eax,20(%esi)
	movl	232(%ecx),%eax
	movl	%eax,24(%esi)
	movl	244(%ecx),%eax
	movl	%eax,28(%esi)
	movl	132(%ecx),%eax
	movl	%eax,32(%esi)
	movl	144(%ecx),%eax
	movl	%eax,36(%esi)
	movl	148(%ecx),%eax
	movl	%eax,40(%esi)
	movl	156(%ecx),%eax
	movl	%eax,44(%esi)
	movl	164(%ecx),%eax
	movl	%eax,48(%esi)
	movl	268(%ecx),%eax
	movl	%eax,52(%esi)
	movl	272(%ecx),%eax
	movl	%eax,56(%esi)
	movl	276(%ecx),%eax
	movl	%eax,60(%esi)
	movl	280(%ecx),%eax
	movl	%eax,64(%esi)

	movl	(%esi),%eax
	movl	8(%esi),%edi
	movl	C(spanlist),%ecx
	movl	%eax,C(freespans)
	addl	4(%esi),%edi
	xorl	%ebp,%ebp
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%edx
	cmpl	%edi,%edx
	jge		LAddToList
	addl	8(%ecx),%edx
	cmpl	%edi,%edx
	jg		LSplitSpan

	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveNoPrev
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	Align16max7
LNextSpan:
	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveSpan
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveSpan
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveSpan
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveSpan
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan
	jmp		LNextSpan

	Align16
LRemoveSpan:
	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	movl	%ecx,(%ebp)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	movl	%ecx,(%ebp)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	movl	%ecx,(%ebp)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	movl	%ecx,(%ebp)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan
	jmp		LRemoveSpan

	Align16
LRemoveNoPrev:
	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan

	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	testl	%ecx,%ecx
	je		LAddToList
	movl	4(%ecx),%eax
	cmpl	%edi,%eax
	jge		LAddToList
	addl	8(%ecx),%eax
	cmpl	%edi,%eax
	jg		LSplitSpan
	jmp		LRemoveNoPrev

	Align16
LSplitSpan:
	movl	C(freespans),%ebx
	testl	%ebx,%ebx
	je		LAddToList
	movl	(%ebx),%eax
	movl	%eax,C(freespans)
	movl	8(%ecx),%eax
	movl	%edi,%edx
	subl	4(%ecx),%edx
	subl	%edx,%eax
	movl	%eax,8(%ebx)
	movl	%edi,4(%ebx)
	movl	%edx,%eax
	imull	32(%ecx),%eax
	addl	12(%ecx),%eax
	movl	%eax,12(%ebx)
	movl	%edx,%eax
	imull	36(%ecx),%eax
	addl	16(%ecx),%eax
	movl	%eax,16(%ebx)
	movl	%edx,28(%esp)
	fildl	28(%esp)
	fld		%st(0)
	fmuls	40(%ecx)
	fadds	20(%ecx)
	fstps	20(%ebx)
	fld		%st(0)
	fmuls	44(%ecx)
	fadds	24(%ecx)
	fstps	24(%ebx)
	fmuls	48(%ecx)
	fadds	28(%ecx)
	fstps	28(%ebx)
	movl	32(%ecx),%eax
	movl	%eax,32(%ebx)
	movl	36(%ecx),%eax
	movl	%eax,36(%ebx)
	movl	40(%ecx),%eax
	movl	%eax,40(%ebx)
	movl	44(%ecx),%eax
	movl	%eax,44(%ebx)
	movl	48(%ecx),%eax
	movl	%eax,48(%ebx)
	movl	52(%ecx),%eax
	movl	%eax,52(%ebx)
	movl	56(%ecx),%eax
	movl	%eax,56(%ebx)
	movl	60(%ecx),%eax
	movl	%eax,60(%ebx)
	movl	64(%ecx),%eax
	movl	%eax,64(%ebx)
	movl	(%ecx),%eax
	movl	%eax,(%ebx)
	movl	%ebx,(%ecx)
	movl	%edx,8(%ecx)

	movl	4(%esi),%eax
	cmpl	%eax,4(%ecx)
	jge		LRemoveSpan2
	movl	%ecx,%ebp
	movl	(%ebp),%ecx
	jmp		LAddToList

	Align16
LRemoveSpan2:
	movl	%ecx,%edx
	movl	(%ecx),%ecx
	movl	C(freespans),%eax
	movl	%eax,(%edx)
	movl	%edx,C(freespans)
	testl	%ebp,%ebp
	je		LAddToList
	movl	%ecx,(%ebp)
	jmp		LAddToList

	Align16
LAddToList:
	movl	%ecx,(%esi)
	testl	%ebp,%ebp
	je		LAddAtHead
	movl	4(%ebp),%eax
	movl	%esi,(%ebp)
	movl	4(%esi),%edx
	subl	%eax,%edx
	cmpl	%edx,8(%ebp)
	jl		LExit2
	movl	%edx,8(%ebp)
	jmp		LExit2

	Align16
LAddAtHead:
	movl	%esi,C(spanlist)

LExit2:
	movl	%esi,%eax
LExit:
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$28,%esp
	ret

	Align16
LExitNull:
	xorl	%eax,%eax
	jmp		LExit

#endif
