//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	A_SnakeAttack
//
//==========================================================================

void A_SnakeAttack(mobj_t* actor)
{
	if (!actor->target)
	{
		SetMobjState(actor, S_SNAKE_WALK1);
		return;
	}
	StartSound(actor, actor->sound_attack);
	A_FaceTarget(actor);
	SpawnMissile(actor, actor->target, MT_SNAKEPRO_A);
}

//==========================================================================
//
//	A_SnakeAttack2
//
//==========================================================================

void A_SnakeAttack2(mobj_t* actor)
{
	if (!actor->target)
	{
		SetMobjState(actor, S_SNAKE_WALK1);
		return;
	}
	StartSound(actor, actor->sound_attack);
	A_FaceTarget(actor);
	SpawnMissile(actor, actor->target, MT_SNAKEPRO_B);
}

