//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.data

	Align4
LC0:
	.long 0x47800000

.text

//==========================================================================
//
//	D_DrawSmoothSpan_15
//
//==========================================================================

	Align16
.globl C(D_DrawSmoothSpan_15)
C(D_DrawSmoothSpan_15):
	movl C(ds_count),%eax
	flds C(ds_s)
	flds C(ds_t)
	flds C(ds_v)
	flds C(ds_dsdx)
	flds C(ds_dtdx)
	flds C(ds_dvdx)
	subl $204,%esp
	pushl %ebp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl %eax,196(%esp)
	movl C(ds_y),%eax
	movl C(ylookup)(,%eax,4),%eax
	movl C(ds_x),%edx
	addl %eax,%eax
	addl C(scrn16),%eax
	addl %edx,%edx
	addl %edx,%eax
	movl C(ds_fr),%edx
	movl C(ds_fdrdx),%ebx
	movl %eax,192(%esp)
	movl %edx,188(%esp)
	movl %ebx,184(%esp)
	jmp L545

	Align16
L546:
	fxch %st(4)
L545:
	flds LC0
	fdiv %st(4),%st
	fld %st(6)
	fmul %st(1),%st
	fxch %st(7)
	movl C(ds_source),%ebx
	fadd %st(4),%st
	fxch %st(7)
	fistpl 180(%esp)
	fld %st(5)
	movl 180(%esp),%esi
	movl C(ds_colormap16),%ebp
	sarl $16,%esi
	fmulp %st,%st(1)
	movl %esi,%edi
	andl $255,%edi
	incl %esi
	andl $255,%esi
	fistpl 176(%esp)
	movl 176(%esp),%ecx
	sarl $16,%ecx
	movl %ecx,%edx
	movzbl %dl,%edx
	sall $8,%edx
	leal (%edi,%edx),%eax
	movzbl (%eax,%ebx),%eax
	movl 188(%esp),%ebx
	sarl $11,%ebx
	andl $7936,%ebx
	addl %ebx,%eax
	movzwl (%ebp,%eax,2),%eax
	movl %eax,%ebp
	shrl $7,%ebp
	movl %ebp,36(%esp)
	movl %eax,%ebp
	andl $31,%eax
	sall $3,%eax
	movl %eax,168(%esp)
	leal (%esi,%edx),%eax
	movl C(ds_source),%edx
	shrl $2,%ebp
	movl %ebp,172(%esp)
	movl C(ds_colormap16),%ebp
	andl $248,36(%esp)
	andl $248,172(%esp)
	incl %ecx
	movzbl %cl,%ecx
	sall $8,%ecx
	addl %ecx,%edi
	addl %esi,%ecx
	movzbl (%eax,%edx),%eax
	addl %ebx,%eax
	movzwl (%ebp,%eax,2),%eax
	movl %eax,%edx
	shrl $7,%edx
	andl $248,%edx
	movl %edx,164(%esp)
	movl C(ds_source),%edx
	movl %eax,%ebp
	shrl $2,%ebp
	movl %ebp,160(%esp)
	movl C(ds_colormap16),%ebp
	andl $248,160(%esp)
	andl $31,%eax
	sall $3,%eax
	movl %eax,156(%esp)
	movzbl (%edi,%edx),%eax
	addl %ebx,%eax
	movzwl (%ebp,%eax,2),%eax
	movl %eax,%edx
	shrl $7,%edx
	andl $248,%edx
	movl %edx,152(%esp)
	movl C(ds_source),%edx
	movl %eax,%ebp
	shrl $2,%ebp
	movl %ebp,148(%esp)
	andl $248,148(%esp)
	andl $31,%eax
	sall $3,%eax
	movl %eax,144(%esp)
	movzbl (%ecx,%edx),%eax
	addl %ebx,%eax
	movl C(ds_colormap16),%ebx
	fadd %st,%st(3)
	fxch %st(4)
	fadd %st(1),%st
	movzwl (%ebx,%eax,2),%eax
	movw $0,182(%esp)
	movl 180(%esp),%ebx
	movl %eax,%ebp
	movl %eax,%edx
	andl $31,%eax
	sall $3,%eax
	movl %eax,132(%esp)
	movl $65536,%eax
	movl %eax,128(%esp)
	subl %ebx,128(%esp)
	movl %eax,%ebx
	movl 128(%esp),%eax
	shrl $2,%edx
	andl $248,%edx
	movl %edx,136(%esp)
	movw $0,178(%esp)
	subl 176(%esp),%ebx
	imull %ebx
	movl %edx,124(%esp)
	movl 36(%esp),%edx
	movl %eax,120(%esp)
	movl 120(%esp),%eax
	movl %edx,28(%esp)
	sarl $31,%edx
	movl %edx,32(%esp)
	mull 28(%esp)
	movl %eax,%edi
	movl 120(%esp),%eax
	imull 32(%esp),%eax
	shrl $7,%ebp
	movl %ebp,140(%esp)
	movl %edx,%ebp
	addl %eax,%ebp
	movl 124(%esp),%eax
	imull 28(%esp),%eax
	addl %eax,%ebp
	movl 180(%esp),%eax
	imull %ebx
	andl $248,140(%esp)
	movl %eax,112(%esp)
	movl %edx,116(%esp)
	movl 164(%esp),%edx
	movl 112(%esp),%eax
	movl %edx,%ebx
	movl %edx,%esi
	mull %ebx
	movl %eax,28(%esp)
	movl 112(%esp),%eax
	sarl $31,%esi
	imull %esi,%eax
	movl %edx,32(%esp)
	addl %eax,%edx
	movl 116(%esp),%eax
	imull %ebx,%eax
	movl %edx,32(%esp)
	addl %eax,32(%esp)
	movl 28(%esp),%eax
	movl 32(%esp),%edx
	movl %ebp,%edi
	sarl $31,%ebp
	movl %edx,%eax
	sarl $31,%edx
	leal (%eax,%edi),%ebx
	movl 128(%esp),%eax
	imull 176(%esp)
	movl %edx,108(%esp)
	movl 152(%esp),%edx
	movl %eax,104(%esp)
	movl 104(%esp),%eax
	movl %edx,%esi
	movl %edx,%edi
	mull %esi
	movl %eax,28(%esp)
	movl 104(%esp),%eax
	sarl $31,%edi
	imull %edi,%eax
	movl %edx,32(%esp)
	addl %eax,%edx
	movl 108(%esp),%eax
	imull %esi,%eax
	movl %edx,32(%esp)
	addl %eax,32(%esp)
	movl 28(%esp),%eax
	movl 32(%esp),%edx
	movl %edx,%eax
	sarl $31,%edx
	addl %eax,%ebx
	movl 180(%esp),%eax
	imull 176(%esp)
	movl %edx,100(%esp)
	movl 140(%esp),%edx
	movl %eax,96(%esp)
	movl 96(%esp),%eax
	movl %edx,%esi
	movl %edx,%edi
	mull %esi
	movl %eax,28(%esp)
	movl 96(%esp),%eax
	sarl $31,%edi
	imull %edi,%eax
	movl %edx,32(%esp)
	addl %eax,%edx
	movl 100(%esp),%eax
	imull %esi,%eax
	movl %edx,32(%esp)
	addl %eax,32(%esp)
	movl 28(%esp),%eax
	movl 32(%esp),%edx
	movl %edx,%eax
	sarl $31,%edx
	movl 172(%esp),%edx
	addl %eax,%ebx
	movl 120(%esp),%eax
	movl %edx,28(%esp)
	sarl $31,%edx
	movl %edx,32(%esp)
	mull 28(%esp)
	movl %eax,%esi
	movl 120(%esp),%eax
	imull 32(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 124(%esp),%eax
	movl 160(%esp),%edx
	imull 28(%esp),%eax
	addl %eax,%edi
	movl 112(%esp),%eax
	movl %edx,88(%esp)
	sarl $31,%edx
	movl %edx,92(%esp)
	mull 88(%esp)
	movl %eax,28(%esp)
	movl 112(%esp),%eax
	imull 92(%esp),%eax
	movl %edx,32(%esp)
	addl %eax,%edx
	movl 88(%esp),%eax
	imull 116(%esp),%eax
	movl %edx,32(%esp)
	addl %eax,32(%esp)
	movl 28(%esp),%eax
	movl 32(%esp),%edx
	movl %edx,%eax
	sarl $31,%edx
	movl 148(%esp),%edx
	movl %edi,%esi
	sarl $31,%edi
	leal (%eax,%esi),%ecx
	movl %edx,80(%esp)
	movl 104(%esp),%eax
	sarl $31,%edx
	movl %edx,84(%esp)
	mull 80(%esp)
	movl %eax,%esi
	movl 104(%esp),%eax
	imull 84(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 80(%esp),%eax
	movl 136(%esp),%edx
	imull 108(%esp),%eax
	addl %eax,%edi
	movl 96(%esp),%eax
	movl %edx,72(%esp)
	sarl $31,%edx
	movl %edx,76(%esp)
	mull 72(%esp)
	movl %edi,%esi
	sarl $31,%edi
	addl %esi,%ecx
	movl %eax,%esi
	movl 96(%esp),%eax
	imull 76(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 72(%esp),%eax
	movl 168(%esp),%edx
	imull 100(%esp),%eax
	addl %eax,%edi
	movl 120(%esp),%eax
	movl %edi,%esi
	sarl $31,%edi
	addl %esi,%ecx
	movl %edx,%esi
	movl %edx,%edi
	mull %esi
	movl %eax,64(%esp)
	movl 120(%esp),%eax
	sarl $31,%edi
	imull %edi,%eax
	movl %edx,68(%esp)
	addl %eax,%edx
	movl 124(%esp),%eax
	imull %esi,%eax
	movl %edx,68(%esp)
	addl %eax,68(%esp)
	movl 64(%esp),%eax
	movl 68(%esp),%edx
	movl %edx,%eax
	sarl $31,%edx
	movl %edx,68(%esp)
	movl 156(%esp),%edx
	movl %eax,64(%esp)
	movl 112(%esp),%eax
	movl %edx,56(%esp)
	sarl $31,%edx
	movl %edx,60(%esp)
	mull 56(%esp)
	movl %eax,%esi
	movl 112(%esp),%eax
	imull 60(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 56(%esp),%eax
	movl 64(%esp),%ebp
	movl 144(%esp),%edx
	imull 116(%esp),%eax
	addl %eax,%edi
	movl %edx,48(%esp)
	movl 104(%esp),%eax
	sarl $31,%edx
	movl %edx,52(%esp)
	mull 48(%esp)
	movl %edi,%esi
	sarl $31,%edi
	addl %esi,%ebp
	movl %eax,%esi
	movl 104(%esp),%eax
	imull 52(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 48(%esp),%eax
	movl 132(%esp),%edx
	imull 108(%esp),%eax
	addl %eax,%edi
	movl 96(%esp),%eax
	movl %edx,40(%esp)
	sarl $31,%edx
	movl %edx,44(%esp)
	mull 40(%esp)
	movl %edi,%esi
	sarl $31,%edi
	addl %esi,%ebp
	movl %eax,%esi
	movl 96(%esp),%eax
	imull 44(%esp),%eax
	movl %edx,%edi
	addl %eax,%edi
	movl 40(%esp),%eax
	imull 100(%esp),%eax
	addl %eax,%edi
	movl %edi,%esi
	sarl $31,%edi
	leal (%esi,%ebp),%edx
	movl 192(%esp),%ebp
	sall $7,%ebx
	andl $31744,%ebx
	sall $2,%ecx
	andl $992,%ecx
	orl %ecx,%ebx
	sarl $3,%edx
	andl $31,%edx
	orl %edx,%ebx
	movw %bx,(%ebp)
	movl 184(%esp),%eax
	addl %eax,188(%esp)
	addl $2,192(%esp)
	decl 196(%esp)
	jnz L546
	fstp %st(0)
	fstp %st(0)
	fstp %st(0)
	fstp %st(0)
	fstp %st(0)
	fstp %st(0)
	popl %ebx
	popl %esi
	popl %edi
	popl %ebp
	addl $204,%esp

	jmp		C(D_DrawZSpan)

#endif
