;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_DATA SEGMENT
 align 4
itransluc:
 dd 0
_DATA ENDS
_TEXT SEGMENT
 align 4
 public _D_DrawFuzzSpriteSpan_16
_D_DrawFuzzSpriteSpan_16:
 sub esp,44
 push ebp
 push edi
 push esi
 push ebx
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 mov eax,ds:dword ptr[_ds_count]
 mov edx,ds:dword ptr[_ds_fz]
 mov ds:dword ptr[36+esp],eax
 mov eax,ds:dword ptr[_ds_fr]
 mov ds:dword ptr[28+esp],eax
 mov ds:dword ptr[32+esp],edx
 mov eax,ds:dword ptr[_ds_y]
 mov edx,ds:dword ptr[_ylookup+eax*4]
 mov ecx,ds:dword ptr[_ds_x]
 add edx,edx
 mov eax,edx
 add eax,ds:dword ptr[_scrn16]
 add ecx,ecx
 lea ebp,ds:dword ptr[ecx+eax]
 add edx,ds:dword ptr[_zbuffer]
 add edx,ecx
 mov ds:dword ptr[24+esp],edx
 mov eax,256
 sub eax,ds:dword ptr[_ds_transluc16]
 mov ds:dword ptr[itransluc],eax
 jmp LEnter
 align 4
LLoop:
 fxch st(1)
 fxch st(2)
 fxch st(1)
LEnter:
 mov edx,ds:dword ptr[24+esp]
 mov eax,ds:dword ptr[32+esp]
 shr eax,16
 cmp ax,ds:word ptr[edx]
 jb LSkipPixel
 fld1
 fdiv st,st(1)
 fld st(3)
 fmul st,st(1)
 fistp ds:dword ptr[40+esp]
 mov ecx,ds:dword ptr[40+esp]
 fld st(2)
 fmulp st(1),st
 fistp ds:dword ptr[40+esp]
 mov eax,ds:dword ptr[40+esp]
 mov edx,ds:dword ptr[_ds_source]
 imul eax,ds:dword ptr[_ds_tex_width]
 add eax,ecx
 mov al,ds:byte ptr[eax+edx]
 cmp al,255
 je LSkipPixel
 movzx edx,al
 mov eax,ds:dword ptr[28+esp]
 mov ecx,ds:dword ptr[_ds_colormap16]
 sar eax,11
 and eax,7936
 add edx,eax
 mov al,ds:byte ptr[1+ebp]
 and al,248
 mov ds:byte ptr[23+esp],al
 movzx ebx,ds:word ptr[ebp]
 mov edi,ds:dword ptr[_ds_transluc16]
 mov esi,ds:dword ptr[itransluc]
 and ebx,2016
 shr bx,3
 movzx ebx,bl
 imul ebx,edi
 mov al,ds:byte ptr[ebp]
 sal al,3
 mov ds:byte ptr[22+esp],al
 movzx eax,ds:word ptr[ecx+edx*2]
 mov cl,ds:byte ptr[1+ecx+edx*2]
 movzx edx,ds:byte ptr[23+esp]
 imul edx,edi
 and cl,248
 mov ds:byte ptr[21+esp],cl
 mov ecx,eax
 sal al,3
 mov ds:byte ptr[20+esp],al
 movzx eax,ds:byte ptr[21+esp]
 imul eax,esi
 and ecx,2016
 shr cx,3
 movzx ecx,cl
 imul ecx,esi
 add edx,eax
 shr edx,8
 mov ds:byte ptr[16+esp],dl
 movzx edx,ds:byte ptr[22+esp]
 imul edx,edi
 movzx eax,ds:byte ptr[20+esp]
 imul eax,esi
 add ebx,ecx
 shr ebx,8
 add edx,eax
 mov cl,ds:byte ptr[16+esp]
 sal ecx,8
 and ecx,offset -2048
 lea eax,ds:dword ptr[0+ebx*8]
 and eax,2016
 or ecx,eax
 shr edx,11
 and edx,31
 or ecx,edx
 mov ds:word ptr[ebp],cx
LSkipPixel:
 fxch st(2)
 mov edx,ds:dword ptr[_ds_fdzdx]
 mov eax,ds:dword ptr[_ds_fdrdx]
 fadd ds:dword ptr[_ds_dsdx]
 fxch st(1)
 fadd ds:dword ptr[_ds_dtdx]
 fxch st(2)
 fadd ds:dword ptr[_ds_dvdx]
 add ds:dword ptr[32+esp],edx
 add ds:dword ptr[28+esp],eax
 add ebp,2
 add ds:dword ptr[24+esp],2
 dec ds:dword ptr[36+esp]
 jnz LLoop
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebx
 pop esi
 pop edi
 pop ebp
 add esp,44
 ret
_TEXT ENDS
 END
