//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.data
	Align4
itransluc:
	.long 0

.text

//==========================================================================
//
//	D_DrawFuzzSpriteSpan_16
//
//==========================================================================

	Align16
.globl C(D_DrawFuzzSpriteSpan_16)
C(D_DrawFuzzSpriteSpan_16):

	subl	$44,%esp
	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx

	flds	C(ds_s)
	flds	C(ds_t)
	flds	C(ds_v)
	movl	C(ds_count),%eax
	movl	C(ds_fz),%edx
	movl	%eax,36(%esp)
	movl	C(ds_fr),%eax
	movl	%eax,28(%esp)
	movl	%edx,32(%esp)
	movl	C(ds_y),%eax
	movl	C(ylookup)(,%eax,4),%edx
	movl	C(ds_x),%ecx
	addl	%edx,%edx
	movl	%edx,%eax
	addl	C(scrn16),%eax
	addl	%ecx,%ecx
	leal	(%ecx,%eax),%ebp
	addl	C(zbuffer),%edx
	addl	%ecx,%edx
	movl	%edx,24(%esp)
	movl	$256,%eax
	subl	C(ds_transluc16),%eax
	movl	%eax,itransluc
	jmp		LEnter

	Align16
LLoop:
	fxch	%st(1)
	fxch	%st(2)
	fxch	%st(1)
LEnter:
	movl	24(%esp),%edx
	movl	32(%esp),%eax
	shrl	$16,%eax
	cmpw	(%edx),%ax
	jb		LSkipPixel
	fld1
	fdiv	%st(1),%st
	fld		%st(3)
	fmul	%st(1),%st
	fistpl	40(%esp)
	movl	40(%esp),%ecx
	fld		%st(2)
	fmulp	%st,%st(1)
	fistpl	40(%esp)
	movl	40(%esp),%eax
	movl	C(ds_source),%edx
	imull	C(ds_tex_width),%eax
	addl	%ecx,%eax
	movb	(%eax,%edx),%al
	cmpb	$255,%al
	je		LSkipPixel
	movzbl	%al,%edx
	movl	28(%esp),%eax
	movl	C(ds_colormap16),%ecx
	sarl	$11,%eax
	andl	$7936,%eax
	addl	%eax,%edx
	movb	1(%ebp),%al
	andb	$248,%al
	movb	%al,23(%esp)
	movzwl	(%ebp),%ebx
	movl	C(ds_transluc16),%edi
	movl	itransluc,%esi
	andl	$2016,%ebx
	shrw	$3,%bx
	movzbl	%bl,%ebx
	imull	%edi,%ebx
	movb	(%ebp),%al
	salb	$3,%al
	movb	%al,22(%esp)
	movzwl	(%ecx,%edx,2),%eax
	movb	1(%ecx,%edx,2),%cl
	movzbl	23(%esp),%edx
	imull	%edi,%edx
	andb	$248,%cl
	movb	%cl,21(%esp)
	movl	%eax,%ecx
	salb	$3,%al
	movb	%al,20(%esp)
	movzbl	21(%esp),%eax
	imull	%esi,%eax
	andl	$2016,%ecx
	shrw	$3,%cx
	movzbl	%cl,%ecx
	imull	%esi,%ecx
	addl	%eax,%edx
	shrl	$8,%edx
	movb	%dl,16(%esp)
	movzbl	22(%esp),%edx
	imull	%edi,%edx
	movzbl	20(%esp),%eax
	imull	%esi,%eax
	addl	%ecx,%ebx
	shrl	$8,%ebx
	addl	%eax,%edx
	movb	16(%esp),%cl
	sall	$8,%ecx
	andl	$-2048,%ecx
	leal	0(,%ebx,8),%eax
	andl	$2016,%eax
	orl		%eax,%ecx
	shrl	$11,%edx
	andl	$31,%edx
	orl		%edx,%ecx
	movw	%cx,(%ebp)
LSkipPixel:
	fxch	%st(2)
	movl	C(ds_fdzdx),%edx
	movl	C(ds_fdrdx),%eax
	fadds	C(ds_dsdx)
	fxch	%st(1)
	fadds	C(ds_dtdx)
	fxch	%st(2)
	fadds	C(ds_dvdx)
	addl	%edx,32(%esp)
	addl	%eax,28(%esp)
	addl	$2,%ebp
	addl	$2,24(%esp)
	decl	36(%esp)
	jnz		LLoop

	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$44,%esp
	ret

#endif
