;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_TEXT SEGMENT
 align 4
 public _D_DrawAltFuzzSpriteSpan_8
_D_DrawAltFuzzSpriteSpan_8:
 sub esp,28
 push ebp
 mov ebp,ds:dword ptr[_ds_fz]
 mov eax,ds:dword ptr[_ds_fr]
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 fld ds:dword ptr[_ds_dsdx]
 fld ds:dword ptr[_ds_dtdx]
 fld ds:dword ptr[_ds_dvdx]
 push edi
 push esi
 push ebx
 mov ds:dword ptr[20+esp],eax
 mov eax,ds:dword ptr[_ds_y]
 mov edx,ds:dword ptr[_ylookup+eax*4]
 mov ecx,ds:dword ptr[_ds_x]
 mov eax,edx
 add eax,ds:dword ptr[_scrn]
 lea ebx,ds:dword ptr[ecx+eax]
 mov eax,ds:dword ptr[_zbuffer]
 mov esi,ds:dword ptr[_ds_count]
 lea edx,ds:dword ptr[eax+edx*2]
 lea edi,ds:dword ptr[edx+ecx*2]
 jmp LEnter
 align 4
LLoop:
 fxch st(3)
 fxch st(4)
 fxch st(5)
LEnter:
 mov eax,ebp
 shr eax,16
 cmp ax,ds:word ptr[edi]
 jb LSkipPixel
 fld1
 fdiv st,st(4)
 fld st(6)
 fmul st,st(1)
 fistp ds:dword ptr[24+esp]
 mov ecx,ds:dword ptr[24+esp]
 fld st(5)
 fmulp st(1),st
 fistp ds:dword ptr[24+esp]
 mov eax,ds:dword ptr[24+esp]
 mov edx,ds:dword ptr[_ds_source]
 imul eax,ds:dword ptr[_ds_tex_width]
 add eax,ecx
 mov al,ds:byte ptr[eax+edx]
 cmp al,255
 je LSkipPixel
 movzx edx,al
 mov eax,ds:dword ptr[20+esp]
 mov ecx,ds:dword ptr[_ds_colormap]
 sar eax,11
 and eax,7936
 add edx,eax
 movzx eax,ds:byte ptr[ebx]
 movzx edx,ds:byte ptr[edx+ecx]
 mov ecx,ds:dword ptr[_ds_transluc]
 sal eax,8
 add eax,edx
 mov al,ds:byte ptr[eax+ecx]
 mov ds:byte ptr[ebx],al
LSkipPixel:
 fxch st(5)
 mov eax,ds:dword ptr[_ds_fdrdx]
 fadd st,st(2)
 fxch st(4)
 fadd st,st(1)
 fxch st(3)
 fadd st,st(5)
 add ebp,ds:dword ptr[_ds_fdzdx]
 add ds:dword ptr[20+esp],eax
 inc ebx
 add edi,2
 dec esi
 jnz LLoop
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebx
 pop esi
 pop edi
 pop ebp
 add esp,28
 ret
_TEXT ENDS
 END
