;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_TEXT SEGMENT
 align 4
 public _D_DrawSpriteSpan_8
_D_DrawSpriteSpan_8:
 sub esp,28
 push ebp
 push edi
 push esi
 push ebx
 mov eax,ds:dword ptr[_ds_fz]
 mov edx,ds:dword ptr[_ds_fr]
 mov ecx,ds:dword ptr[_ds_x]
 fld ds:dword ptr[_ds_s]
 fld ds:dword ptr[_ds_t]
 fld ds:dword ptr[_ds_v]
 mov edi,ds:dword ptr[_ds_count]
 mov ds:dword ptr[20+esp],eax
 mov eax,ds:dword ptr[_ds_y]
 mov ds:dword ptr[16+esp],edx
 mov edx,ds:dword ptr[_ylookup+eax*4]
 mov eax,edx
 add eax,ds:dword ptr[_scrn]
 lea ebp,ds:dword ptr[ecx+eax]
 mov eax,ds:dword ptr[_zbuffer]
 lea edx,ds:dword ptr[eax+edx*2]
 lea esi,ds:dword ptr[edx+ecx*2]
 jmp LEnter
 align 4
LLoop:
 fxch st(1)
 fxch st(2)
 fxch st(1)
LEnter:
 mov ebx,ds:dword ptr[20+esp]
 shr ebx,16
 cmp bx,ds:word ptr[esi]
 jb LSkipPixel
 fld1
 fdiv st,st(1)
 fld st(3)
 fmul st,st(1)
 fistp ds:dword ptr[24+esp]
 mov ecx,ds:dword ptr[24+esp]
 fld st(2)
 fmulp st(1),st
 fistp ds:dword ptr[24+esp]
 mov eax,ds:dword ptr[24+esp]
 imul eax,ds:dword ptr[_ds_tex_width]
 mov edx,ds:dword ptr[_ds_source]
 add eax,ecx
 mov al,ds:byte ptr[eax+edx]
 cmp al,255
 je LSkipPixel
 xor edx,edx
 mov dl,al
 mov eax,ds:dword ptr[16+esp]
 sar eax,11
 and eax,7936
 mov ecx,ds:dword ptr[_ds_colormap]
 add edx,eax
 mov al,ds:byte ptr[edx+ecx]
 mov ds:byte ptr[ebp],al
 mov ds:word ptr[esi],bx
LSkipPixel:
 fxch st(2)
 fadd ds:dword ptr[_ds_dsdx]
 fxch st(1)
 mov eax,ds:dword ptr[_ds_fdzdx]
 add ds:dword ptr[20+esp],eax
 fadd ds:dword ptr[_ds_dtdx]
 fxch st(2)
 mov edx,ds:dword ptr[_ds_fdrdx]
 add ds:dword ptr[16+esp],edx
 inc ebp
 add esi,2
 fadd ds:dword ptr[_ds_dvdx]
 dec edi
 jnz LLoop
 fstp st(0)
 fstp st(0)
 fstp st(0)
 pop ebx
 pop esi
 pop edi
 pop ebp
 add esp,28
 ret
_TEXT ENDS
 END
